package com.persagy.parser;

import java.text.SimpleDateFormat;

import cn.hutool.core.util.NumberUtil;
import com.alibaba.fastjson.JSON;

/**
 * @author:LuoGuangyi
 * @company:PersagyTechnologyCo.,Ltd
 * @since:2021/04/01 09:59
 * @version:V1.0
 **/
public class DatagramParser {
	private static final DatagramParser INSTANCE = new DatagramParser();

	private DatagramParser() {
	}

	public static DatagramParser Instance() {
		return INSTANCE;
	}

	public ParserEntity parser(String[] splitContent) throws Exception {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
		ParserEntity result = new ParserEntity();
		result.building = splitContent[0];
		result.gateway = splitContent[1];
		result.packageId = splitContent[4];
		if (splitContent != null && splitContent.length > 2) {
			String datatype = splitContent[2];
			result.datatype = datatype;
			if ("report".equals(splitContent[2]) || "reportack".equals(splitContent[2]) || "text".equals(splitContent[2])
					|| "textack".equals(splitContent[2])) {
				String time = splitContent[3];
				String packageSign = splitContent[5];
				int functionCount = NumberUtil.parseInt(splitContent[6]);
				for (int i = 0; i < functionCount; ++i) {
					String funcid = splitContent[7 + i * 2];
					RecordData recordData = new RecordData();
					recordData.meter = packageSign;
					recordData.funcid = funcid;
					recordData.time = sdf.parse(time);
					recordData.value = splitContent[8 + i * 2];
					result.dataList.add(recordData);
				}
			} else if ("happening".equals(splitContent[2]) || "happeningack".equals(splitContent[2])) {
				String time = splitContent[3];
				{
					RecordData recordData = new RecordData();
					recordData.time = sdf.parse(time);
					recordData.happeningType = splitContent[5];
					StringBuffer happeningContent = new StringBuffer();
					for (int i = 6; i < splitContent.length; i++) {
						if (happeningContent.length() > 0) {
							happeningContent.append(";");
						}
						happeningContent.append(splitContent[i]);
					}
					recordData.happeningContent = JSON.parseObject(happeningContent.toString());
					result.dataList.add(recordData);
				}
			} else if ("reportpointset".equals(splitContent[2])) {
				String time = splitContent[3];
				String packageSign = splitContent[5];
				{
					String funcid = splitContent[6 + 0 * 2];
					RecordData recordData = new RecordData();
					recordData.meter = packageSign;
					recordData.funcid = funcid;
					recordData.time = sdf.parse(time);
					recordData.value = splitContent[7];
					recordData.endtime = sdf.parse(splitContent[8]);
					recordData.result = splitContent[9];
					result.dataList.add(recordData);
				}
			} else if ("senddownreadack".equals(splitContent[2])) {
				String time = splitContent[3];
				String packageSign = splitContent[5];
				{
					String funcid = splitContent[6 + 0 * 2];
					RecordData recordData = new RecordData();
					recordData.meter = packageSign;
					recordData.funcid = funcid;
					recordData.time = sdf.parse(time);
					recordData.endtime = sdf.parse(splitContent[7]);
					recordData.result = splitContent[8];
					recordData.value = splitContent[9];
					result.dataList.add(recordData);
				}
			} else if ("senddownset".equals(splitContent[2])) {
				String time = splitContent[3];
				String packageSign = splitContent[5];
				{
					String funcid = splitContent[6 + 0 * 2];
					RecordData recordData = new RecordData();
					recordData.meter = packageSign;
					recordData.funcid = funcid;
					recordData.time = sdf.parse(time);
					recordData.value = splitContent[7];
					result.dataList.add(recordData);
				}
			} else if ("senddownsetack".equals(splitContent[2])) {
				String time = splitContent[3];
				String packageSign = splitContent[5];
				{
					String funcid = splitContent[6 + 0 * 2];
					RecordData recordData = new RecordData();
					recordData.meter = packageSign;
					recordData.funcid = funcid;
					recordData.time = sdf.parse(time);
					recordData.value = splitContent[7];
					recordData.endtime = sdf.parse(splitContent[8]);
					recordData.result = splitContent[9];
					result.dataList.add(recordData);
				}
			}
		}

		return result;
	}
}