package com.persagy.simulator_gaopin;

import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.simulator.MeterSimulatorWalker;
import com.persagy.util.ExcelSheet;
import com.persagy.util.ExcelUtil;
import com.persagy.util.FastJsonReaderUtil;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;

import java.io.File;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.*;

@Slf4j
public class Constant {
    static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
    public static final List<String> types = Arrays.asList("double","integer","boolean","enum","acc");
    public static String socket_or_mqtt = "socket";

    public static MqttConnectOptions mqtt_options;
    public static String mqtt_clientId;
    public static String mqtt_topic_prefix;

    public static String PROTOCOL = "UDP";
    public static String ServerIP;
    public static int ServerPort;

    public static String Mode = "mina";
    public static int Max_size = 10000;
    public static int SleepCount = 1000;
    public static boolean Separate = false;
    public static String Separate_begin = "(";
    public static String Separate_end = ")";
    public static boolean Compress = false;

    public static int pointupload_period_second = 30;
    public static boolean BatchSend = false;
    public static int BatchCount = 10;
    public static boolean TimeStart_enable = false;
    public static Date TimeStart;
    public static int TimeBeiShu;

    public static boolean use_excel = false;
    public static boolean random_timeout = false;

    public static List<EntityBuilding> buildingList = new ArrayList<EntityBuilding>();
    public static Map<String, EntityBuilding> buildingMap = new HashMap<String, EntityBuilding>();

    public static Map<String, DoubleTimeObject> setDataMap = new HashMap<String, DoubleTimeObject>();
    public static Map<String, String> set2report = new HashMap<String, String>();
    public static Map<String, DoubleTimeObject> reportDataMap = new HashMap<String, DoubleTimeObject>();

    public static Map<String, JSONArray> formula_paramMap = new HashMap<String, JSONArray>();
    public static Map<String, MeterSimulatorWalker> walkerMap = new HashMap<String, MeterSimulatorWalker>();

    public static class Millisecond {
        public static final long MINUTE = 1000L * 60;
        public static final long MINUTE_5 = 1000L * 60 * 5;
        public static final long HOUR = 1000L * 60 * 60;
        public static final long DAY = 1000L * 60 * 60 * 24;
    }

    public static InputStream getStream(String resourc) {
        if (resourc.startsWith(File.separator)) {
            resourc = StrUtil.removePrefix(resourc, File.separator);
        }
        try {
            String filePath = File.separator + "usr" + File.separator + "local" + File.separator + "etc" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 0 " + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级config目录
            String filePath = System.getProperty("user.dir") + File.separator + "config" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 1" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级目录
            String filePath = System.getProperty("user.dir") + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                log.warn("getStream success 2" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // ClassPath目录
            InputStream in = new org.springframework.core.io.ClassPathResource(File.separator + resourc).getInputStream();
            if (in != null) {
                log.warn("getStream success 3" + "\t" + "ClassPathResource" + "\t" + resourc);
                return in;
            }
        } catch (Exception e) {
        }
        try {
            InputStream stream = Constant.class.getResourceAsStream(File.separator + resourc);
            if (stream != null) {
                log.warn("getStream success 4" + "\t" + "getResourceAsStream" + "\t" + resourc);
                return stream;
            }
        } catch (Exception e) {
        }
        log.warn("getStream fail " + resourc);
        return null;
    }

    static {


        try {
            InputStream inputStream = getStream("config.xml");
            SAXReader saxReader = new SAXReader();
            Document document = saxReader.read(inputStream);
            Iterator iter;
            Element element;

            iter = document.selectNodes("/root/socket_or_mqtt").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                socket_or_mqtt = element.getText();
            }

            if (socket_or_mqtt.equals("mqtt")) {
                mqtt_options = new MqttConnectOptions();
                mqtt_options.setAutomaticReconnect(true);
                mqtt_options.setCleanSession(false);
                mqtt_options.setMaxInflight(16384);
                // mqtt_options.setConnectionTimeout(100);
                // mqtt_options.setKeepAliveInterval(20);
                iter = document.selectNodes("/root/mqtt").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    String[] serverURIs = new String[1];
                    serverURIs[0] = element.attribute("url").getValue();
                    String clientId = element.attribute("clientId").getValue();
                    String username = element.attribute("username").getValue();
                    String password = element.attribute("password").getValue();
                    String topic_prefix = element.attribute("topic_prefix").getValue();
                    mqtt_options.setServerURIs(serverURIs);
                    mqtt_options.setUserName(username);
                    mqtt_options.setPassword(password.toCharArray());
                    mqtt_clientId = clientId;
                    mqtt_topic_prefix = topic_prefix;
                }

            } else if (socket_or_mqtt.equals("socket")) {
                iter = document.selectNodes("/root/PROTOCOL").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    PROTOCOL = element.getText();
                }
                iter = document.selectNodes("/root/ServerIP").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    ServerIP = element.getText();
                }
                iter = document.selectNodes("/root/ServerPort").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    ServerPort = NumberUtil.parseInt(element.getText());
                }

                iter = document.selectNodes("/root/Mode").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    Mode = element.getText();
                }
                iter = document.selectNodes("/root/Max_size").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    Max_size = NumberUtil.parseInt(element.getText());
                }
                iter = document.selectNodes("/root/SleepCount").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    SleepCount = NumberUtil.parseInt(element.getText());
                }
                iter = document.selectNodes("/root/Separate").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    String elementText = element.getText();
                    if (elementText != null && elementText.equals("true")) {
                        Separate = true;
                    }
                }
                iter = document.selectNodes("/root/Separate_begin").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    Separate_begin = element.getText();
                }
                iter = document.selectNodes("/root/Separate_end").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    Separate_end = element.getText();
                }
                iter = document.selectNodes("/root/Compress").iterator();
                if (iter.hasNext()) {
                    element = (Element) iter.next();
                    String elementText = element.getText();
                    if (elementText != null && elementText.equals("true")) {
                        Compress = true;
                    }
                }
            }

            iter = document.selectNodes("/root/pointupload_period_second").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                pointupload_period_second = NumberUtil.parseInt(element.getText());
            }
            iter = document.selectNodes("/root/BatchSend").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                String elementText = element.getText();
                if (elementText != null && elementText.equals("true")) {
                    BatchSend = true;
                }
            }
            iter = document.selectNodes("/root/BatchCount").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                BatchCount = NumberUtil.parseInt(element.getText());
            }
            iter = document.selectNodes("/root/TimeStart_enable").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                String elementText = element.getText();
                if (elementText != null && elementText.equals("true")) {
                    TimeStart_enable = true;
                }
            }
            iter = document.selectNodes("/root/TimeStart").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                TimeStart = sdf.parse(element.getText());
            }
            iter = document.selectNodes("/root/TimeBeiShu").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                TimeBeiShu = NumberUtil.parseInt(element.getText());
            }

            iter = document.selectNodes("/root/use_excel").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                String elementText = element.getText();
                if (elementText != null && elementText.equals("true")) {
                    use_excel = true;
                }
            }
            iter = document.selectNodes("/root/random_timeout").iterator();
            if (iter.hasNext()) {
                element = (Element) iter.next();
                String elementText = element.getText();
                if (elementText != null && elementText.equals("true")) {
                    random_timeout = true;
                }
            }

            iter = document.selectNodes("/root/building").iterator();
            while (iter.hasNext()) {
                element = (Element) iter.next();
                String id = element.attributeValue("id");
                if (!buildingMap.containsKey(id)) {
                    EntityBuilding buildingInner = new EntityBuilding();
                    buildingInner.id = id;
                    buildingMap.put(id, buildingInner);
                    buildingList.add(buildingInner);
                }
                EntityBuilding building = buildingMap.get(id);
                log.warn("building:" + id);
                Iterator iterInner = element.selectNodes("group").iterator();
                while (iterInner.hasNext()) {
                    Element elementInner = (Element) iterInner.next();
                    EntityGroup group = new EntityGroup();
                    group.meter_from = NumberUtil.parseInt(elementInner.attributeValue("meter_from"));
                    group.meter_to = NumberUtil.parseInt(elementInner.attributeValue("meter_to"));
                    group.funcid = NumberUtil.parseInt(elementInner.attributeValue("funcid"));
                    group.period_second = NumberUtil.parseInt(elementInner.attributeValue("period_second"));
                    group.data_type = elementInner.attributeValue("data_type");
                    if (group.data_type.equals("double")) {
                    } else if (group.data_type.equals("integer")) {
                    }
                    building.reportGroupList.add(group);

                    // log.warn(" meter_from:" + group.meter_from + " meter_to:" + group.meter_to + " funcid:" + group.funcid
                    // + " period_second:" + group.period_second + " data_type:" + group.data_type);
                }
                log.warn("building:" + id + "\t" + building.reportGroupList.size());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            JSONObject param = FastJsonReaderUtil.Instance().ReadJSONObject(getStream("formula.json"));
            Iterator<String> keyIter = param.keySet().iterator();
            while (keyIter.hasNext()) {
                String key = keyIter.next();
                String expression = (String) param.get(key);
                walkerMap.put(key, SimulatorUtil.getWalker(expression));
            }
        } catch (Exception e1) {
            e1.printStackTrace();
        }

        try {
            Read_formula_param("formula-param.json", formula_paramMap);
        } catch (Exception e1) {
            e1.printStackTrace();
        }

        try {
            if (use_excel) {
                Map<String, ExcelSheet> sheetMap = ExcelUtil.Read(getStream("report.xlsx"), true);
                Iterator<String> keyIter = sheetMap.keySet().iterator();
                while (keyIter.hasNext()) {
                    String key = keyIter.next();
                    String bd = key.substring(2);
                    ExcelSheet sheet = sheetMap.get(key);
                    if (!buildingMap.containsKey(bd)) {
                        EntityBuilding buildingInner = new EntityBuilding();
                        buildingInner.id = bd;
                        buildingMap.put(bd, buildingInner);
                        buildingList.add(buildingInner);
                    }
                    EntityBuilding building = buildingMap.get(bd);
                    log.warn("building:" + bd);
                    for (List<String> contentList : sheet.contentListList) {
                        if (contentList.get(0) == null) {
                            break;
                        }
                        EntityGroup group = new EntityGroup();
                        group.meter = contentList.get(0);
                        group.funcid = NumberUtil.parseInt(contentList.get(1));
                        group.data_type = contentList.get(2).toLowerCase();
                        group.period_second = NumberUtil.parseInt(contentList.get(3));
                        if(!types.contains(group.data_type)){
                            log.warn("丢弃一行不合法参数:{}", JSON.toJSONString(group));
                            continue;
                        }
                        if(group.period_second<=0){
                            log.warn("丢弃一行不合法参数:{}", JSON.toJSONString(group));
                            continue;
                        }
                        if(!ObjectUtil.isAllNotEmpty(group.meter,group.funcid)){
                            log.warn("丢弃一行不合法参数:{}", JSON.toJSONString(group));
                            continue;
                        }
                        if (contentList.get(4) != null && contentList.get(4).trim().length() > 0
                                && !contentList.get(4).trim().equalsIgnoreCase("null")) {
                            group.lower_limit = Double.parseDouble(contentList.get(4).trim());
                        }
                        if (contentList.get(5) != null && contentList.get(5).trim().length() > 0
                                && !contentList.get(5).trim().equalsIgnoreCase("null")) {
                            group.upper_limit = Double.parseDouble(contentList.get(5).trim());
                        }
                        if (contentList.get(6) != null && contentList.get(6).trim().length() > 0
                                && !contentList.get(6).trim().equalsIgnoreCase("null")) {
                            group.rel_set_sign = contentList.get(6).trim();
                        }
                        if (contentList.get(7) != null && contentList.get(7).trim().length() > 0
                                && !contentList.get(7).trim().equalsIgnoreCase("null")) {
                            group.rel_set_funcid = NumberUtil.parseInt(contentList.get(7).trim());
                        }
                        building.reportGroupList.add(group);
                        if (group.rel_set_sign != null) {
                            set2report.put(building.id + "-" + group.rel_set_sign + "-" + group.rel_set_funcid,
                                    building.id + "-" + group.meter + "-" + group.funcid);
                        }

                        reportDataMap.put(building.id + "-" + group.meter + "-" + group.funcid, new DoubleTimeObject());

                        // log.warn(" meter:" + group.meter + " funcid:" + group.funcid + " period_second:" + group.period_second
                        // + " data_type:" + group.data_type);
                    }
                    log.warn("building:" + building.id + "\t" + sheet.contentListList.size());
                }
            }

            if (use_excel) {
                Map<String, ExcelSheet> sheetMap = ExcelUtil.Read(getStream("set.xlsx"), true);
                Iterator<String> keyIter = sheetMap.keySet().iterator();
                while (keyIter.hasNext()) {
                    String key = keyIter.next();
                    String bd = key.substring(2);
                    ExcelSheet sheet = sheetMap.get(key);
                    if (!buildingMap.containsKey(bd)) {
                        EntityBuilding buildingInner = new EntityBuilding();
                        buildingInner.id = bd;
                        buildingMap.put(bd, buildingInner);
                        buildingList.add(buildingInner);
                    }
                    EntityBuilding building = buildingMap.get(bd);
                    for (List<String> contentList : sheet.contentListList) {
                        if (contentList.get(0) == null) {
                            break;
                        }
                        EntityGroup group = new EntityGroup();
                        group.meter = contentList.get(0);
                        group.funcid = NumberUtil.parseInt(contentList.get(1));
                        group.data_type = contentList.get(2).toLowerCase();
                        if (contentList.get(3) != null && contentList.get(3).trim().length() > 0
                                && !contentList.get(3).trim().equalsIgnoreCase("null")) {
                            group.manual_sign = contentList.get(3).trim();
                        }
                        if (contentList.get(4) != null && contentList.get(4).trim().length() > 0
                                && !contentList.get(4).trim().equalsIgnoreCase("null")) {
                            group.manual_funcid = NumberUtil.parseInt(contentList.get(4).trim());
                        }
                        if (group.data_type.equals("double")) {
                        } else if (group.data_type.equals("integer") || group.data_type.equals("boolean") || group.data_type.equals("enum")) {
                        } else {
                            continue;
                        }
                        building.setGroupList.add(group);

                        setDataMap.put(building.id + "-" + group.meter + "-" + group.funcid, new DoubleTimeObject());
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void Read_formula_param(String filename, Map<String, JSONArray> formula_paramMap) throws Exception {
        JSONObject json = FastJsonReaderUtil.Instance().ReadJSONObject(getStream(filename));
        Iterator<String> keyIter = json.keySet().iterator();
        while (keyIter.hasNext()) {
            String key = keyIter.next();
            JSONArray fpArray = (JSONArray) json.get(key);
            JSONArray paramsArray = new JSONArray();
            Read_formula_param_one(fpArray, paramsArray);
            formula_paramMap.put(key, paramsArray);
        }
    }

    private static void Read_formula_param_one(JSONArray fpArray, JSONArray paramsArray) throws Exception {
        for (int i = 0; i < fpArray.size(); i++) {
            JSONObject fp = fpArray.getJSONObject(i);
            String formula = fp.getString("formula");
            JSONObject params = fp.getJSONObject("params");
            Object[] keyArray = params.keySet().toArray();
            int[] indexArray = new int[keyArray.length];
            while (true) {
                JSONObject fa = new JSONObject();
                fa.put("formula", formula);
                JSONObject params_real = new JSONObject();
                for (int ii = 0; ii < keyArray.length; ii++) {
                    String key = (String) keyArray[ii];
                    Object po = params.get(key);
                    if (po instanceof JSONObject) {
                        JSONObject param = (JSONObject) po;
                        double first = param.getDouble("first");
                        double seed = param.getDouble("seed");
                        params_real.put(key, first + seed * indexArray[ii]);
                    } else {
                        params_real.put(key, po);
                    }
                }
                fa.put("params", params_real);
                paramsArray.add(fa);

                //
                boolean finish = false;
                indexArray[0]++;
                for (int ii = 0; ii < keyArray.length; ii++) {
                    String key = (String) keyArray[ii];
                    Object po = params.get(key);
                    long count;
                    if (po instanceof JSONObject) {
                        JSONObject param = (JSONObject) po;
                        count = param.getLong("count");
                    } else {
                        count = 1;
                    }
                    if (indexArray[ii] == count) {
                        if (ii == keyArray.length - 1) {
                            finish = true;
                            break;
                        }
                        indexArray[ii] = 0;
                        indexArray[ii + 1]++;
                    }
                }
                if (finish) {
                    break;
                }
            }
        }
    }

    static boolean reached = false;
    static Date base_time;

    public static synchronized Date getTime() {
        if (!Constant.TimeStart_enable) {
            return new Date();
        }

        if (base_time == null) {
            base_time = new Date();
        }

        Date curr_time;
        Date real_time = new Date();
        if (!reached) {
            if (TimeStart.getTime() + (real_time.getTime() - base_time.getTime()) * TimeBeiShu > real_time.getTime()) {
                curr_time = real_time;
                reached = true;
            } else {
                curr_time = new Date(TimeStart.getTime() + (real_time.getTime() - base_time.getTime()) * TimeBeiShu);
            }
        } else {
            curr_time = real_time;
        }
        curr_time = new Date(curr_time.getTime() / 1000L * 1000L);
        return curr_time;
    }
}
