package com.persagy.simulator_gaopin;

import java.text.SimpleDateFormat;

import lombok.extern.slf4j.Slf4j;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.parser.ParserEntity;
import com.persagy.parser.RecordData;
import com.persagy.util.ProcessUtil;
@Slf4j
public class MyMqttCallback implements MqttCallback {
	// public Queue<ParserEntity> queue = new ConcurrentLinkedDeque<ParserEntity>();

	MixClientManager MixClientManager;
	public String topic_prefix;

	public MyMqttCallback(MixClientManager MixClientManager, String topic_prefix) {
		this.MixClientManager = MixClientManager;
		this.topic_prefix = topic_prefix;
	}

	public void connectionLost(Throwable cause) {
		System.out.println("connection lost: " + cause.getMessage());
	}

	public void deliveryComplete(IMqttDeliveryToken token) {
	}

	/**
	 * @param topic
	 * @param message
	 * @throws Exception
	 */
	public void messageArrived(String topic, MqttMessage message) throws Exception {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
		try {
			// int id = message.getId();
			// int qos = message.getQos();
			String topix_suffix = topic.substring(topic_prefix.length() + 1);
			int index_ = topix_suffix.indexOf('/');
			String building = topix_suffix.substring(0, index_);
			String topicName = topix_suffix.substring(index_ + 1);
			byte[] payload = message.getPayload();
			String stringMessage = new String(payload, "UTF-8");
			JSONObject jsonMessage = JSON.parseObject(stringMessage);
			String packet_type = jsonMessage.getString("packet_type");
			if (topicName.equals("report")) {
			} else if (topicName.equals("setdown")) {
				String mqtt_client_id = jsonMessage.getString("mqtt_client_id");
				long sequence_no = jsonMessage.getLong("sequence_no");
				if (mqtt_client_id.equals(MixClientManager.MqttClient.getClientId())) {
					if (packet_type.equals("pointset")) {
						log.warn(jsonMessage.toJSONString());
						ParserEntity ParserEntity = new ParserEntity();
						ParserEntity.building = building;
						ParserEntity.gateway = "0";
						ParserEntity.packageId = "" + sequence_no;
						ParserEntity.datatype = packet_type;
						JSONArray content = jsonMessage.getJSONArray("content");
						for (int i = 0; i < content.size(); i++) {
							JSONObject contentItem = content.getJSONObject(i);
							RecordData RecordData = new RecordData();
							RecordData.meter = contentItem.getString("meter");
							RecordData.funcid = contentItem.getString("funcid");
							RecordData.time = sdf.parse(contentItem.getString("time"));
							RecordData.value = contentItem.getString("value");
							ParserEntity.dataList.add(RecordData);
						}
						ProcessUtil.Process_senddownset(MixClientManager, building, ParserEntity);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			log.error(e.getMessage());
		}
	}
}