package com.persagy.simulator_gaopin;

import lombok.extern.slf4j.Slf4j;
import org.eclipse.paho.client.mqttv3.MqttTopic;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;
@Slf4j
public class SimulatorMain_collector {

	public static void main(String[] args) throws Exception {

		MixClientManager MixClientManager = new MixClientManager();
		MixClientManager.Start();

		List<Thread_report> thread_reportList = new ArrayList<Thread_report>();
		List<Thread_set> thread_setList = new ArrayList<Thread_set>();
		for (int index = 0; index < Constant.buildingList.size(); index++) {
			EntityBuilding building = Constant.buildingList.get(index);

			MixClientManager.topicMapMap.putIfAbsent(building.id, new ConcurrentHashMap<String, MqttTopic>());
			if (Constant.socket_or_mqtt.equals("mqtt")) {
				MqttTopic topic_report = MixClientManager.MqttClient.getTopic(Constant.mqtt_topic_prefix + "/" + building.id + "/report");
				MixClientManager.topicMapMap.get(building.id).put("report", topic_report);
			}
			if (Constant.socket_or_mqtt.equals("mqtt")) {
				MqttTopic topic_report = MixClientManager.MqttClient.getTopic(Constant.mqtt_topic_prefix + "/" + building.id + "/setup");
				MixClientManager.topicMapMap.get(building.id).put("setup", topic_report);
			}
			if (Constant.socket_or_mqtt.equals("mqtt")) {
				MqttTopic topic_report = MixClientManager.MqttClient.getTopic(Constant.mqtt_topic_prefix + "/" + building.id + "/setdown");
				MixClientManager.topicMapMap.get(building.id).put("setdown", topic_report);
			}

			Thread_report thread_report = new Thread_report(building, MixClientManager);
			thread_report.start();
			thread_reportList.add(thread_report);

			for (EntityGroup group : building.setGroupList) {
				building.groupMap.put(group.meter + "-" + group.funcid, group);
			}
			Thread_set thread_set = new Thread_set(building, MixClientManager);
			thread_set.thread_report = thread_report;
			thread_set.start();
			thread_setList.add(thread_set);
			
			if(MixClientManager.mode.equals("mqtt")){
				MixClientManager.MqttClient.subscribe(Constant.mqtt_topic_prefix + "/" + building.id + "/setdown");
			}
		}

		Date last_time = new Date((new Date()).getTime() / 1000L * 1000L);
		while (true) {
			Thread.sleep(1L);

			Date curr_time = new Date((new Date()).getTime() / 1000L * 1000L);
			if (curr_time.getTime() > last_time.getTime()) {
				int recent = PacketRepository.pop();
				if (recent > 0) {
					log.warn("recent count:" + "\t" + recent);
				}

				last_time = curr_time;
			}
		}
	}

}
