package com.persagy.simulator_gaopin;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.persagy.parser.ParserEntity;
import com.persagy.parser.RecordData;
import com.persagy.util.PacketNumGenerator;

public class Thread_report extends Thread {
	EntityBuilding building;

	public Thread_report(EntityBuilding building, MixClientManager MixClientManager) {
		this.building = building;
		this.MixClientManager = MixClientManager;
	}

	// IClientManager clientManager;
	MixClientManager MixClientManager;
	long packageId = 1;
	SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
	DecimalFormat df = new DecimalFormat("#.##");

	public void run() {
		while (true) {
			try {
				Thread.sleep(1L);
			} catch (Exception e) {
				e.printStackTrace();
			}

			Date curr_time = Constant.getTime();
			List<ParserEntity> packetList = new ArrayList<ParserEntity>();
			for (EntityGroup group : this.building.reportGroupList) {
				int funcid = group.funcid;
				if (group.last_time == null || (curr_time.getTime() - group.last_time.getTime() >= group.period_second * 1000L)) {
					group.last_time = curr_time;
				} else {
					continue;
				}
				try {
					if (group.meter == null) {
						for (int meter = group.meter_from; meter <= group.meter_to; meter++) {
							this.doOne(group, "" + meter, funcid, group.data_type, packetList, curr_time);
						}
					} else {
						this.doOne(group, group.meter, funcid, group.data_type, packetList, curr_time);
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			} // end for
			if (packetList.size() > 0) {
				this.Send(packetList);
			}
		} // end while
	}

	int count_acc = 0;
	int count_sleep = 1;

	private void Send(List<ParserEntity> packetList) {
		MixClientManager.report(packetList);
		PacketRepository.add(1);
		count_acc += packetList.size();
		packetList.clear();

		if (count_acc >= count_sleep) {
			count_acc = 0;
			try {
				Thread.sleep(1L);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	private void Send(ParserEntity packet) {
		List<ParserEntity> packetList = new ArrayList<ParserEntity>();
		packetList.add(packet);
		MixClientManager.report(packetList);
		PacketRepository.add(1);

		count_acc++;
		if (count_acc >= count_sleep) {
			count_acc = 0;
			try {
				Thread.sleep(1L);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	public synchronized void doOne(EntityGroup group, String meter, int funcid, String data_type, List<ParserEntity> packetList, Date curr_time)
			throws Exception {
		Object dataString;
		String key = building.id + "-" + group.rel_set_sign + "-" + group.rel_set_funcid;
		if (group.rel_set_sign != null && Constant.setDataMap.containsKey(key)) {
			dataString = "" + Constant.setDataMap.get(key).data;
		} else {
			dataString = SimulatorUtil.getValue(group, meter, funcid, data_type, curr_time,building.id + "-" + meter + "-" + funcid);
			Constant.reportDataMap.get(building.id + "-" + meter + "-" + funcid).data = Double.parseDouble(dataString.toString());
		}
		ParserEntity packet = new ParserEntity();
		packet.building = building.id;
		packet.gateway = "0";
		packet.datatype = "report";
		packet.packageId = "" + PacketNumGenerator.Instance().Generate();
		RecordData RecordData = new RecordData();
		RecordData.meter = meter;
		RecordData.funcid = "" + funcid;
		RecordData.time = curr_time;
		RecordData.value = dataString.toString();
		packet.dataList.add(RecordData);
		if (Constant.BatchSend) {
			packetList.add(packet);
			if (packetList.size() >= Constant.BatchCount) {
				this.Send(packetList);
			}
		} else {
			this.Send(packet);
		}

		if (packageId >= 65535) {
			packageId = 1;
		}
	}

	public synchronized void sendOne(String meter, int funcid, double data) {
		Date curr_time = new Date();
		ParserEntity packet = new ParserEntity();
		packet.building = building.id;
		packet.gateway = "0";
		packet.datatype = "report";
		packet.packageId = "" + PacketNumGenerator.Instance().Generate();
		RecordData RecordData = new RecordData();
		RecordData.meter = meter;
		RecordData.funcid = "" + funcid;
		RecordData.time = curr_time;
		RecordData.value = "" + data;
		packet.dataList.add(RecordData);
		this.Send(packet);
	}
}