package com.persagy.simulator_gaopin;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

import lombok.extern.slf4j.Slf4j;
import org.eclipse.paho.client.mqttv3.MqttMessage;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.communication.entity.Packet;
import com.persagy.parser.DatagramParser;
import com.persagy.parser.ParserEntity;
import com.persagy.util.PacketNumGenerator;
import com.persagy.util.ProcessUtil;
@Slf4j
public class Thread_set extends Thread {
	EntityBuilding building;

	public Thread_set(EntityBuilding building, MixClientManager MixClientManager) {
		this.building = building;
		this.MixClientManager = MixClientManager;
	}

	MixClientManager MixClientManager;
	long packageId = 1;
	Random rand = new Random();
	SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
	DecimalFormat df = new DecimalFormat("#.########");

	public Thread_report thread_report;

	public void run() {
		Date last_upload_time = null;
		while (true) {
			try {
				Thread.sleep(1L);
			} catch (Exception e) {
				e.printStackTrace();
			}

			Date curr_time = new Date((new Date()).getTime() / 1000L * 1000L);
			if (last_upload_time == null || curr_time.getTime() - last_upload_time.getTime() >= 1000L * Constant.pointupload_period_second) {
				last_upload_time = curr_time;
				try {
					this.pointupload();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}

			if (MixClientManager.ClientManager != null) {
				while (true) {
					Packet packet = MixClientManager.ClientManager.PopRece();
					if (packet == null) {
						break;
					}

					try {
						String[] splits = packet.packetString.split(";");
						if (splits[2].equals("senddownset")) {
							ParserEntity ParserEntity = DatagramParser.Instance().parser(splits);
							log.warn("rece: " + packet.packetString);
							ProcessUtil.Process_senddownset(MixClientManager, building.id, ParserEntity);
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		} // end while
	}

	private void pointupload() throws Exception {
		int yerongliang = 10;
		int zoneyeshu = (this.building.setGroupList.size() + yerongliang - 1) / yerongliang;
		for (int i = 0; i < zoneyeshu; i++) {
			int yebianhao = i + 1;
			List<EntityGroup> groupList = new ArrayList<EntityGroup>();
			for (int ii = i * yerongliang; ii < (i + 1) * yerongliang && ii < this.building.setGroupList.size(); ii++) {
				groupList.add(this.building.setGroupList.get(ii));
			}
			if (MixClientManager.mode.equals("socket")) {
				StringBuffer sb = new StringBuffer();
				sb.append(this.building.id + ";1;pointupload;;123;" + yerongliang + ";" + zoneyeshu + ";" + yebianhao + ";" + groupList.size());
				for (EntityGroup group : groupList) {
					sb.append(";" + group.meter + ";" + group.funcid);
				}
				MixClientManager.ClientManager.AppendToSend(new Packet(sb.toString()));
			} else if (MixClientManager.mode.equals("mqtt")) {
				JSONObject pointset = new JSONObject();
				pointset.put("sequence_no", PacketNumGenerator.Instance().Generate());
				pointset.put("mqtt_client_id", MixClientManager.MqttClient.getClientId());
				pointset.put("packet_type", "pointupload");
				JSONArray content = new JSONArray();
				for (EntityGroup group : groupList) {
					JSONObject contentItem = new JSONObject();
					contentItem.put("meter", group.meter);
					contentItem.put("funcid", "" + group.funcid);
					content.add(contentItem);
				}
				pointset.put("content", content);
				try {
					MqttMessage message = new MqttMessage(pointset.toString().getBytes("UTF-8"));
					MixClientManager.topicMapMap.get(this.building.id).get("setup").publish(message);
				} catch (Exception e) {
				}

			}
		}
	}
}