package com.persagy.util;

import com.persagy.entity.ValueObject;

import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.Date;

public class FunctionUtil {

	public static ValueObject constant(String constant) {
		ValueObject result = new ValueObject();
		result.type = 1;
		if (constant.equals("PI")) {
			result.doubleValue = Math.PI;
		} else if (constant.equals("E")) {
			result.doubleValue = Math.E;
		}
		return result;
	}

	public static ValueObject compute(String function) {
		ValueObject result = new ValueObject();
		result.type = 1;
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function, new Class[] {});
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] {});
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	public static ValueObject compute(String function, ValueObject a) {
		ValueObject result = new ValueObject();
		result.type = 1;
		double valuea;
		if (a.type == 0) {
			valuea = a.intValue;
		} else {
			valuea = a.doubleValue;
		}
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function,
					new Class[] { double.class });
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] { valuea });
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	public static ValueObject compute(String function, ValueObject a,
			ValueObject b) {
		ValueObject result = new ValueObject();
		result.type = 1;
		double valuea;
		if (a.type == 0) {
			valuea = a.intValue;
		} else {
			valuea = a.doubleValue;
		}
		double valueb;
		if (b.type == 0) {
			valueb = b.intValue;
		} else {
			valueb = b.doubleValue;
		}
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function, new Class[] {
					double.class, double.class });
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] { valuea, valueb });
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	public static ValueObject computedate(String function, ValueObject a) {
		ValueObject result = new ValueObject();
		if (a.type == 1) {
			return result;
		}

		Calendar calendar = Calendar.getInstance();
		calendar.setTime(new Date(a.intValue));
		if (function.equals("dateyear")) {
			result.intValue = calendar.get(Calendar.YEAR);
		} else if (function.equals("datemonth")) {
			result.intValue = calendar.get(Calendar.MONTH) + 1;
		} else if (function.equals("dateday")) {
			result.intValue = calendar.get(Calendar.DAY_OF_MONTH);
		} else if (function.equals("datedayofweek")) {
			result.intValue = calendar.get(Calendar.DAY_OF_WEEK);
		} else if (function.equals("datedayofmonth")) {
			result.intValue = calendar.get(Calendar.DAY_OF_MONTH);
		} else if (function.equals("datedayofyear")) {
			result.intValue = calendar.get(Calendar.DAY_OF_YEAR);
		} else if (function.equals("datehour")) {
			result.intValue = calendar.get(Calendar.HOUR_OF_DAY);
		} else if (function.equals("dateminute")) {
			result.intValue = calendar.get(Calendar.MINUTE);
		} else if (function.equals("datesecond")) {
			result.intValue = calendar.get(Calendar.SECOND);
		}
		return result;
	}
}
