package com.persagy.util;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Random;

import cn.hutool.core.util.NumberUtil;
import com.persagy.parser.ParserEntity;
import com.persagy.parser.RecordData;
import com.persagy.simulator_gaopin.Constant;
import com.persagy.simulator_gaopin.DoubleTimeObject;
import com.persagy.simulator_gaopin.EntityGroup;
import com.persagy.simulator_gaopin.MixClientManager;

public class ProcessUtil {
	public static Random rand = new Random();

	public static void Process_senddownset(MixClientManager MixClientManager, String building, ParserEntity ParserEntity) throws Exception {
		Map<String, EntityGroup> groupMap = Constant.buildingMap.get(building).groupMap;
		Date curr_time = new Date();
		for (RecordData RecordData : ParserEntity.dataList) {
			if (Constant.random_timeout) {
				boolean timeout = rand.nextBoolean();
				if (timeout) {
					RecordData.result = "failure_timeout";
					RecordData.endtime = curr_time;
					continue;
				}
			}
			String meter = RecordData.meter;
			String funcid = RecordData.funcid;
			double value = Double.parseDouble(RecordData.value);
			if (!groupMap.containsKey(meter + "-" + funcid)) {
				RecordData.result = "failure_point_not_exist";
				RecordData.endtime = curr_time;
				continue;
			}
			EntityGroup group = groupMap.get(meter + "-" + funcid);
			if (group.manual_sign != null) {
				DoubleTimeObject manualData = Constant.reportDataMap.get(building + "-" + group.manual_sign + "-" + group.manual_funcid);
				if (manualData.data != 0.0) {
					RecordData.result = "failure_manual_is_auto";
					RecordData.endtime = curr_time;
					continue;
				}
			}
			if (group.data_type.equalsIgnoreCase("boolean")) {
				if (value != 0.0 && value != 1.0) {
					RecordData.result = "failure_boolean_cant_set_" + value;
					RecordData.endtime = curr_time;
					continue;
				}
			} else if (group.data_type.equalsIgnoreCase("enum")) {
				if (value != (long) value) {
					RecordData.result = "failure_boolean_cant_set_" + value;
					RecordData.endtime = curr_time;
					continue;
				}
			}
			{
				RecordData.result = "success";
				RecordData.endtime = curr_time;
				Constant.setDataMap.get(building + "-" + meter + "-" + funcid).data = value;
				if (Constant.set2report.containsKey(building + "-" + meter + "-" + funcid)) {
					String mf = Constant.set2report.get(building + "-" + meter + "-" + funcid);
					int index_ = mf.indexOf("-");
					int index__ = mf.lastIndexOf("-");
					String report_meter = mf.substring(index_ + 1, index__);
					int report_funcid = NumberUtil.parseInt(mf.substring(index__ + 1));
					Constant.reportDataMap.get(building + "-" + report_meter + "-" + report_funcid).data = value;

					ParserEntity packet = new ParserEntity();
					packet.building = building;
					packet.gateway = "0";
					packet.datatype = "report";
					packet.packageId = "" + PacketNumGenerator.Instance().Generate();
					RecordData RecordDataInner = new RecordData();
					RecordDataInner.meter = report_meter;
					RecordDataInner.funcid = "" + report_funcid;
					RecordDataInner.time = curr_time;
					RecordDataInner.value = RecordData.value;
					packet.dataList.add(RecordDataInner);
					List<ParserEntity> packetList = new ArrayList<ParserEntity>();
					packetList.add(packet);
					MixClientManager.report(packetList);
				}
			}
		}
		MixClientManager.senddownsetack(ParserEntity);
	}
}
