package com.persagy.util;

import com.persagy.entity.ValueObject;

public class ValueObjectUtil {
	public static ValueObject compute(String operator, ValueObject a,
									  ValueObject b) {
		ValueObject result = new ValueObject();
		if (a.type == 0 && b.type == 0) {
			if (operator.equals("+")) {
				result.intValue = a.intValue + b.intValue;
			} else if (operator.equals("-")) {
				result.intValue = a.intValue - b.intValue;
			} else if (operator.equals("*")) {
				result.intValue = a.intValue * b.intValue;
			} else if (operator.equals("/")) {
				result.intValue = a.intValue / b.intValue;
			} else if (operator.equals("%")) {
				result.intValue = a.intValue % b.intValue;
			}
		} else {
			result.type = 1;
			double valuea;
			if (a.type == 0) {
				valuea = a.intValue;
			} else {
				valuea = a.doubleValue;
			}
			double valueb;
			if (b.type == 0) {
				valueb = b.intValue;
			} else {
				valueb = b.doubleValue;
			}
			if (operator.equals("+")) {
				result.doubleValue = valuea + valueb;
			} else if (operator.equals("-")) {
				result.doubleValue = valuea - valueb;
			} else if (operator.equals("*")) {
				result.doubleValue = valuea * valueb;
			} else if (operator.equals("/")) {
				result.doubleValue = valuea / valueb;
			} else if (operator.equals("%")) {
				result.doubleValue = valuea % valueb;
			}
		}
		return result;
	}

	public static boolean compare(String operator, ValueObject a, ValueObject b) {
		if (a.type == 0 && b.type == 0) {
			if (operator.equals("<")) {
				return a.intValue < b.intValue;
			} else if (operator.equals("<=")) {
				return a.intValue <= b.intValue;
			} else if (operator.equals(">")) {
				return a.intValue > b.intValue;
			} else if (operator.equals(">=")) {
				return a.intValue >= b.intValue;
			} else if (operator.equals("==")) {
				return a.intValue == b.intValue;
			} else if (operator.equals("!=")) {
				return a.intValue != b.intValue;
			}
		} else {
			double valuea;
			if (a.type == 0) {
				valuea = a.intValue;
			} else {
				valuea = a.doubleValue;
			}
			double valueb;
			if (b.type == 0) {
				valueb = b.intValue;
			} else {
				valueb = b.doubleValue;
			}
			if (operator.equals("<")) {
				return valuea < valueb;
			} else if (operator.equals("<=")) {
				return valuea <= valueb;
			} else if (operator.equals(">")) {
				return valuea > valueb;
			} else if (operator.equals(">=")) {
				return valuea >= valueb;
			} else if (operator.equals("==")) {
				return valuea == valueb;
			} else if (operator.equals("!=")) {
				return valuea != valueb;
			}
		}
		return true;
	}
}
